Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Email receiving Estimated time: 0.00 hour

Target version: 2.6.2   

Resolution: Fixed Affected version: 2.6.1

Description

rdm-mailhandler.rb should catch EOFError in addition to SystemCallError at 

source:trunk/extra/mail_handler/rdm-mailhandler.rb@13872#L132.

If communications between rdm-mailhandler.rb and Redmine are terminated while rdm-mailhandler.rb talking to Redmine, Net::HTTP

raises EOFError and rdm-mailhandler stops unexpectedly because it does not catch EOFError. The email will be bounced.

error mail from MTAerror mail from MTA

This is the mail system at host mta.example.com

I'm sorry to have to inform you that your message could not

be delivered to one or more recipients. It's attached below.

For further assistance, please send mail to postmaster.

If you do so, please include this problem report. You can

delete your own text from the attached returned message.

                   The mail system

<redmine@example.com>: Command died

    with status 1: "/some/where/redmine/extra/mail_handler/rdm-mailhandler.rb

    --url http://redmine.example.com/redmine/ --key **********

    --allow-override=tracker,category,priority --project=someproject

    --unknown-user=accept --no-permission-check". Command output:

    /usr/share/ruby/2.0/net/protocol.rb:153:in `read_nonblock': end of file

    reached (EOFError)  from /usr/share/ruby/2.0/net/protocol.rb:153:in

    `rbuf_fill'  from /usr/share/ruby/2.0/net/protocol.rb:134:in `readuntil'

    from /usr/share/ruby/2.0/net/protocol.rb:144:in `readline'  from

    /usr/share/ruby/2.0/net/http/response.rb:39:in `read_status_line'  from

    /usr/share/ruby/2.0/net/http/response.rb:28:in `read_new'  from

    /usr/share/ruby/2.0/net/http.rb:1406:in `block in transport_request'  from

    /usr/share/ruby/2.0/net/http.rb:1403:in `catch'  from

    /usr/share/ruby/2.0/net/http.rb:1403:in `transport_request'  from

    /usr/share/ruby/2.0/net/http.rb:1376:in `request'  from

    /some/where/redmine/extra/mail_handler/rdm-mailhandler.rb:36:in `block in

    post_form'  from /usr/share/ruby/2.0/net/http.rb:852:in `start'  from

    /some/where/redmine/extra/mail_handler/rdm-mailhandler.rb:36:in `post_form'

    from /some/where/redmine/extra/mail_handler/rdm-mailhandler.rb:131:in

    `submit'  from

    /some/where/redmine/extra/mail_handler/rdm-mailhandler.rb:178:in `<main>'

We can avoid the preceding by this patch. The email will be deferred, not bounced.

Associated revisions

Revision 13961 - 2015-02-07 08:37 - Jean-Philippe Lang

rdm-mailhandler.rb should catch EOFError (#18922).

Patch by Go MAEDA.
https://www.redmine.org/projects/redmine/repository/svn/revisions/13872/entry/trunk/extra/mail_handler/rdm-mailhandler.rb#L132


Revision 14022 - 2015-02-18 12:35 - Jean-Philippe Lang

Merged r13961 (#18922).

History

#1 - 2015-01-31 15:30 - Jean-Philippe Lang

Maybe we could even catch IOError which is the superclass of EOFError?

#2 - 2015-02-01 03:07 - Go MAEDA

Jean-Philippe Lang wrote:

Maybe we could even catch IOError which is the superclass of EOFError?

 Indeed. To deal with a variety of situations, catching IOError is better solition.

Thank you for pointing it out.

#3 - 2015-02-01 03:18 - Go MAEDA

- File catch-IOError.diff added

Here is a new patch. Catches IOError instead of EOFError.

#4 - 2015-02-07 08:37 - Jean-Philippe Lang

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Target version set to 2.6.2

- Resolution set to Fixed

Patch committed in r13961, thanks.

#5 - 2015-02-18 12:35 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Files

catch-EOFError.diff 669 Bytes 2015-01-21 Go MAEDA

catch-IOError.diff 668 Bytes 2015-02-01 Go MAEDA
